//+------------------------------------------------------------------+
//|                                                  Correlation.mq4 |
//|                                                             CLF. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "CLF."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_minimum -1
#property indicator_maximum 1

extern int count = 10;
double Buff_1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
SetIndexBuffer(0,Buff_1);
SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2,Red);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
//----

//r = [n?xy - ?x?y]  v[n?x^2 - (?x)^2][n?y^2 - (?y)^2] ? is summation, v is sqrt
double Ex;
double Ey;
double Exy;
double Ex2;  
double Ey2;
double Num;
double Denom;
double x, y;
double correlation;
int i;
int n,q;
//------
int    counted_bars=IndicatorCounted();
   i=Bars-counted_bars-1;
   while(i>=0)
   {   
x =0;
y =0;
Ex =0;
Ey =0;
Exy =0;
Ex2 =0;
Ey2 =0;

for (q = i; q <= i+count; q++)  
  { 
  x = Close[q];
  y = iCCI(NULL,0,count,5,q);             // The indicator to be correlated
  Ex = x + Ex;
  Ey = y + Ey;
  Exy = x*y + Exy;
  Ex2 = MathPow(x,2) + Ex2;
  Ey2 = MathPow(y,2) + Ey2;
  }


//r = [n?xy - ?x?y]  v[n?x^2 - (?x)^2][n?y^2 - (?y)^2] ? is summation, v is sqrt
n = count;
Num = (n*Exy)-(Ex*Ey);
Denom = MathSqrt(((n*Ex2 )- MathPow(Ex,2))*((n*Ey2) - MathPow(Ey,2)));  

if (Denom != 0)
   correlation = Num/Denom;

Buff_1[i] = correlation;
i--;
}
//----
   return(0);
  }
//+------------------------------------------------------------------+